// ############################################
// Calendar Program
// Anders Rasmussen
// January 29, 2000

// Based on a calendar program
// I made for unix

// Thanks to by Xavier Vassor and Jean Canazzi
// for their great gcc compiler
// ############################################

#include <romcalls.h>	// include file for rom calls

#define clr_scr	graphlib__0005
#define idle_loop userlib__0000

void idle_loop();	// prototype for idle_loop();
void clr_scr();		// prototype for clr_scr();

int _ti89; // compile for the ti-89 (_ti92plus)

/* Global Variables */
int mdays[12]={31,28,31,30,31,30,31,31,30,31,30,31}; //days in a each month
int moff[12]={0,3,3,6,1,4,6,2,5,0,3,5}; //month offsets
char mname[12][10]={"January","February","March","April","May","June","July","August","September","October","November","December"};

/* Functions */

int getday(int m,int d,int y)
{
 int dayoff,monthoff,yearoff,cenoff,leap;
 dayoff=d%7;
 monthoff=moff[m-1];

 if (m<3&&(y%4==0))
  leap=1;
 else
  leap=0;

 yearoff=((y%100)+((y%100)/4)-leap)%7;
 cenoff=((y/400)*4+3-(y/100))*2;
 return (cenoff+yearoff+monthoff+dayoff)%7;
}

void display(int m,int year)
{
 char temp[20];
 int offset,leap,i,x,y;
 sprintf(temp,"%s, %d",mname[m-1],year);
 clr_scr();
 DrawStr(0,8,temp,4);
 DrawStr(0,20,"Su  Mo  Tu  We  Th  Fr  Sa",4);
 offset=getday(m,1,year);

 if (m==2&&year%4==0)
  leap=1;
 else
  leap=0;

 x=offset;y=0;
 for (i=0;i<(mdays[m-1]+leap);i++)
 {
  sprintf(temp,"%d",i+1);
  DrawStr(x*24,y*10+28,temp,4);
  x++;
  if (x>6)
  {
   y++; x=0;
  }
 }
}

void _main()
{
 int month=1,year=2000;
 int done=0,menu=0,input;
 char temp[30];
 clr_scr();
 FontSetSys(2);
 DrawStr(55,0,"Calendar",4);
 FontSetSys(1);
 DrawStr(23,10,"by Anders Rasmussen",4);
 while (!done)
 {
  if (menu==0)
  {
   DrawStr(43,30,"Select Month",0);
   sprintf(temp,"%s      ",mname[month-1]);
   DrawStr(43,38,temp,4);
   DrawStr(43,54,"Select Year",4);
   sprintf(temp,"%d ",year);
   DrawStr(43,62,temp,4);
  }
  else
  {
   DrawStr(43,30,"Select Month",4);
   sprintf(temp,"%s     ",mname[month-1]);
   DrawStr(43,38,temp,4);
   DrawStr(43,54,"Select Year",0);
   sprintf(temp,"%d ",year);
   DrawStr(43,62,temp,4);
  }
  input=ngetchx();
  if (input==337||input==340)
  {
   if (menu==0)
    menu=1;
   else
    menu=0;
  }
  if (input==338)
  {
   if (menu==0)
   {
    month--;
    if (month<1) month=12;
   }
   else
   {
    year--;
    if (year<0) year=0;
   }
  }
  if (input==344)
  {
   if (menu==0)
   {
    month++;
    if (month>12) month=1;
   }
   else
   {
    year++;
    if (year>9999) year=9999;
   }
  }
  if (input==264)
   break;
  if (input==13)
   done=1;
 }

 // display calendar loop
 done=0;
 while (!done)
 {
  display(month,year);
  input=ngetchx(); 

  if (input==337)
  {year++; if (year>9999) year=9999;}
  if (input==340)
  {year--; if (year<0) year=0;}
  if (input==338)
  {month--; if (month<1) month=12;}
  if (input==344)
  {month++; if (month>12) month=1;}
  if (input==264)
   break;
  if (input==277)
   done=1;
 }
}
